# Makefile fragment for pdfxTeX and web2c. --infovore@xs4all.nl. Public domain.
# This fragment contains the parts of the makefile that are most likely to
# differ between releases of pdfxTeX.

Makefile: $(srcdir)/pdfxtexdir/pdfxtex.mk

# We build pdfxtex
pdfxtex = pdfxtex
pdfxtexdir = pdfxtexdir

# The C sources.
pdfxtex_c = pdfxtexini.c pdfxtex0.c pdfxtex1.c pdfxtex2.c pdfxtex3.c
pdfxtex_o = pdfxtexini.o pdfxtex0.o pdfxtex1.o pdfxtex2.o pdfxtex3.o pdfxtexextra.o

# Making pdfxtex
pdfxtex: pdftexd.h $(pdfxtex_o) $(pdfxtexextra_o) $(pdftexlibsdep)
	@CXXHACKLINK@ $(pdfxtex_o) $(pdfxtexextra_o) $(pdftexlibs) $(socketlibs) @CXXHACKLDLIBS@ @CXXLDEXTRA@

# C file dependencies.
$(pdfxtex_c) pdfxtexcoerce.h pdfxtexd.h: pdfxtex.p $(web2c_texmf)
	$(web2c) pdfxtex
pdfxtexextra.c: lib/texmfmp.c
	sed s/TEX-OR-MF-OR-MP/pdfxtex/ $(srcdir)/lib/texmfmp.c >$@

# Tangling
pdfxtex.p pdfxtex.pool: tangle pdfxtex.web pdfxtex.ch
	./tangle pdfxtex.web pdfxtex.ch

# Generation of the web and ch file.
pdfxtex.web: tie tex.web \
             etexdir/etex.ch0 \
             etexdir/etex.ch \
             etexdir/etex.fix \
             etexdir/etex.ch1 \
             pdfetexdir/pdfetex.ch1 \
             pdftexdir/pdftex.ch \
             pdftexdir/hz.ch \
             pdftexdir/misc.ch \
             pdfxtexdir/vadjust.ch \
             pdfxtexdir/strcmp.ch \
             pdfxtexdir/pdfxtex.ch2 \
             pdfxtexdir/pdfxtex.h \
             pdfxtexdir/pdfxtex.defines \
             pdfxtexdir/pdfxtex.mk
	./tie -m pdfxtex.web $(srcdir)/tex.web \
		$(srcdir)/etexdir/etex.ch0 \
		$(srcdir)/etexdir/etex.ch \
		$(srcdir)/etexdir/etex.fix \
		$(srcdir)/etexdir/etex.ch1 \
		$(srcdir)/pdfetexdir/pdfetex.ch1 \
		$(srcdir)/pdftexdir/pdftex.ch \
		$(srcdir)/pdftexdir/hz.ch \
		$(srcdir)/pdftexdir/misc.ch \
		$(srcdir)/pdfxtexdir/vadjust.ch \
		$(srcdir)/pdfxtexdir/strcmp.ch \
		$(srcdir)/pdfxtexdir/pdfxtex.ch2
pdfxtex.ch: tie pdfxtex.web  \
            tex.ch \
            etexdir/tex.ch1 \
            etexdir/tex.ech \
            etexdir/tex.ch2 \
            pdfxtexdir/tex.ch0 \
            pdfxtexdir/tex.ch1 \
            pdftexdir/tex.pch \
            pdfxtexdir/tex.ch2 \
            pdfxtexdir/pdfxtex.mk
	./tie -c pdfxtex.ch pdfxtex.web \
		$(srcdir)/pdfxtexdir/tex.ch0 \
		$(srcdir)/tex.ch \
		$(srcdir)/etexdir/tex.ch1 \
		$(srcdir)/etexdir/tex.ech \
		$(srcdir)/etexdir/tex.ch2 \
		$(srcdir)/pdfxtexdir/tex.ch1 \
		$(srcdir)/pdftexdir/tex.pch \
		$(srcdir)/pdfxtexdir/tex.ch2

$(srcdir)/pdfxtexdir/pdfxtex.h: $(srcdir)/pdftexdir/pdftex.h
	cp -f $(srcdir)/pdftexdir/pdftex.h $@

$(srcdir)/pdfxtexdir/pdfxtex.defines: $(srcdir)/pdftexdir/pdftex.defines
	cp -f $(srcdir)/pdftexdir/pdftex.defines $@

check: pdfxtex-check
pdfxtex-check: pdfxtex pdfxtex.efmt

clean:: pdfxtex-clean
pdfxtex-clean:
	$(LIBTOOL) --mode=clean $(RM) pdfxtex
	rm -f $(pdfxtex_o) $(pdfxtex_c) pdfxtexextra.c pdfxtexcoerce.h
	rm -f pdfxtexd.h pdfxtex.p pdfxtex.pool pdfxtex.web pdfxtex.ch
	rm -f pdfxtex.efmt pdfxtex.log

# Dumps
all_pdfxfmts = pdfxtex.efmt $(pdfxfmts)
pdfxfmts: $(all_pdfxfmts)

pdfxtex.efmt: pdfxtex
	$(dumpenv) $(MAKE) progname=pdfxtex files="etex.src plain.tex cmr10.tfm" prereq-check
	$(dumpenv) ./pdfxtex --progname=pdfxtex --jobname=pdfxtex --ini \*\\pdfoutput=1\\input etex.src \\dump </dev/null

pdfxlatex.efmt: pdfxtex
	$(dumpenv) $(MAKE) progname=pdfxlatex files="latex.ltx" prereq-check
	$(dumpenv) ./pdfxtex --progname=pdfxlatex --jobname=pdfxlatex --ini \*\\pdfoutput=1\\input latex.ltx </dev/null

pdflatex.efmt: pdfxtex
	$(dumpenv) $(MAKE) progname=pdflatex files="latex.ltx" prereq-check
	$(dumpenv) ./pdfxtex --progname=pdflatex --jobname=pdflatex --ini \*\\pdfoutput=1\\input latex.ltx </dev/null


# Installation.
install-pdfxtex: install-pdfxtex-exec install-pdfxtex-data
install-pdfxtex-exec: install-pdfxtex-links
install-pdfxtex-data:: install-pdfxtex-dumps
install-pdfxtex-dumps: install-pdfxtex-fmts

# The actual binary executables and pool files.
install-programs: install-pdfxtex-programs
install-pdfxtex-programs: $(pdfxtex) $(bindir)
	for p in pdfxtex; do $(INSTALL_LIBTOOL_PROG) $$p $(bindir); done

install-links: install-pdfxtex-links
install-pdfxtex-links: install-pdfxtex-programs
	cd $(bindir) && (rm -f inipdfxtex virpdfxtex; \
	  $(LN) pdfxtex inipdfxtex; $(LN) pdfxtex virpdfxtex)
	pdfxfmts="$(pdfxfmts)";
	  for f in $$pdfxfmts; do base=`basename $$f .efmt`; \
	    (cd $(bindir) && (rm -f $$base; $(LN) pdfxtex $$base)); done

install-fmts: install-pdfxtex-fmts
install-pdfxtex-fmts: pdfxfmts $(fmtdir)
	pdfxfmts="$(all_pdfxfmts)";
	  for f in $$pdfxfmts; do $(INSTALL_DATA) $$f $(fmtdir)/$$f; done

# Auxiliary files.
install-data install-pdfxtex-data:: $(texpooldir)
	$(INSTALL_DATA) pdfxtex.pool $(texpooldir)/pdfxtex.pool

# end of pdfxtex.mk
